package com.hfkj.dao;

import com.hfkj.entity.BsOrderStarbucks;
import com.hfkj.entity.BsOrderStarbucksExample.Criteria;
import com.hfkj.entity.BsOrderStarbucksExample.Criterion;
import com.hfkj.entity.BsOrderStarbucksExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderStarbucksSqlProvider {

    public String countByExample(BsOrderStarbucksExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_starbucks");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderStarbucksExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_starbucks");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderStarbucks record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_starbucks");
        
        if (record.getStoreCode() != null) {
            sql.VALUES("store_code", "#{storeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformCode() != null) {
            sql.VALUES("platform_code", "#{platformCode,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformUniqueId() != null) {
            sql.VALUES("platform_unique_id", "#{platformUniqueId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.VALUES("product_id", "#{productId,jdbcType=INTEGER}");
        }
        
        if (record.getCupSize() != null) {
            sql.VALUES("cup_size", "#{cupSize,jdbcType=VARCHAR}");
        }
        
        if (record.getTemperature() != null) {
            sql.VALUES("temperature", "#{temperature,jdbcType=VARCHAR}");
        }
        
        if (record.getCream() != null) {
            sql.VALUES("cream", "#{cream,jdbcType=VARCHAR}");
        }
        
        if (record.getEspresso() != null) {
            sql.VALUES("espresso", "#{espresso,jdbcType=VARCHAR}");
        }
        
        if (record.getMilk() != null) {
            sql.VALUES("milk", "#{milk,jdbcType=VARCHAR}");
        }
        
        if (record.getMilkBubble() != null) {
            sql.VALUES("milk_bubble", "#{milkBubble,jdbcType=VARCHAR}");
        }
        
        if (record.getNum() != null) {
            sql.VALUES("num", "#{num,jdbcType=INTEGER}");
        }
        
        if (record.getImg() != null) {
            sql.VALUES("img", "#{img,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.VALUES("`name`", "#{name,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.VALUES("child_order_no", "#{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.VALUES("user_phone", "#{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getPrice() != null) {
            sql.VALUES("price", "#{price,jdbcType=DECIMAL}");
        }
        
        if (record.getStoreAddress() != null) {
            sql.VALUES("store_address", "#{storeAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.VALUES("store_name", "#{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderStarbucksExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("store_code");
        sql.SELECT("platform_code");
        sql.SELECT("platform_unique_id");
        sql.SELECT("product_id");
        sql.SELECT("cup_size");
        sql.SELECT("temperature");
        sql.SELECT("cream");
        sql.SELECT("espresso");
        sql.SELECT("milk");
        sql.SELECT("milk_bubble");
        sql.SELECT("num");
        sql.SELECT("img");
        sql.SELECT("`name`");
        sql.SELECT("order_no");
        sql.SELECT("child_order_no");
        sql.SELECT("mer_id");
        sql.SELECT("user_id");
        sql.SELECT("user_phone");
        sql.SELECT("price");
        sql.SELECT("store_address");
        sql.SELECT("store_name");
        sql.SELECT("pay_type");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_starbucks");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderStarbucks record = (BsOrderStarbucks) parameter.get("record");
        BsOrderStarbucksExample example = (BsOrderStarbucksExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_starbucks");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getStoreCode() != null) {
            sql.SET("store_code = #{record.storeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformCode() != null) {
            sql.SET("platform_code = #{record.platformCode,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformUniqueId() != null) {
            sql.SET("platform_unique_id = #{record.platformUniqueId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{record.productId,jdbcType=INTEGER}");
        }
        
        if (record.getCupSize() != null) {
            sql.SET("cup_size = #{record.cupSize,jdbcType=VARCHAR}");
        }
        
        if (record.getTemperature() != null) {
            sql.SET("temperature = #{record.temperature,jdbcType=VARCHAR}");
        }
        
        if (record.getCream() != null) {
            sql.SET("cream = #{record.cream,jdbcType=VARCHAR}");
        }
        
        if (record.getEspresso() != null) {
            sql.SET("espresso = #{record.espresso,jdbcType=VARCHAR}");
        }
        
        if (record.getMilk() != null) {
            sql.SET("milk = #{record.milk,jdbcType=VARCHAR}");
        }
        
        if (record.getMilkBubble() != null) {
            sql.SET("milk_bubble = #{record.milkBubble,jdbcType=VARCHAR}");
        }
        
        if (record.getNum() != null) {
            sql.SET("num = #{record.num,jdbcType=INTEGER}");
        }
        
        if (record.getImg() != null) {
            sql.SET("img = #{record.img,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        }
        
        if (record.getStoreAddress() != null) {
            sql.SET("store_address = #{record.storeAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_starbucks");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("store_code = #{record.storeCode,jdbcType=VARCHAR}");
        sql.SET("platform_code = #{record.platformCode,jdbcType=VARCHAR}");
        sql.SET("platform_unique_id = #{record.platformUniqueId,jdbcType=VARCHAR}");
        sql.SET("product_id = #{record.productId,jdbcType=INTEGER}");
        sql.SET("cup_size = #{record.cupSize,jdbcType=VARCHAR}");
        sql.SET("temperature = #{record.temperature,jdbcType=VARCHAR}");
        sql.SET("cream = #{record.cream,jdbcType=VARCHAR}");
        sql.SET("espresso = #{record.espresso,jdbcType=VARCHAR}");
        sql.SET("milk = #{record.milk,jdbcType=VARCHAR}");
        sql.SET("milk_bubble = #{record.milkBubble,jdbcType=VARCHAR}");
        sql.SET("num = #{record.num,jdbcType=INTEGER}");
        sql.SET("img = #{record.img,jdbcType=VARCHAR}");
        sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        sql.SET("store_address = #{record.storeAddress,jdbcType=VARCHAR}");
        sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderStarbucksExample example = (BsOrderStarbucksExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderStarbucks record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_starbucks");
        
        if (record.getStoreCode() != null) {
            sql.SET("store_code = #{storeCode,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformCode() != null) {
            sql.SET("platform_code = #{platformCode,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformUniqueId() != null) {
            sql.SET("platform_unique_id = #{platformUniqueId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{productId,jdbcType=INTEGER}");
        }
        
        if (record.getCupSize() != null) {
            sql.SET("cup_size = #{cupSize,jdbcType=VARCHAR}");
        }
        
        if (record.getTemperature() != null) {
            sql.SET("temperature = #{temperature,jdbcType=VARCHAR}");
        }
        
        if (record.getCream() != null) {
            sql.SET("cream = #{cream,jdbcType=VARCHAR}");
        }
        
        if (record.getEspresso() != null) {
            sql.SET("espresso = #{espresso,jdbcType=VARCHAR}");
        }
        
        if (record.getMilk() != null) {
            sql.SET("milk = #{milk,jdbcType=VARCHAR}");
        }
        
        if (record.getMilkBubble() != null) {
            sql.SET("milk_bubble = #{milkBubble,jdbcType=VARCHAR}");
        }
        
        if (record.getNum() != null) {
            sql.SET("num = #{num,jdbcType=INTEGER}");
        }
        
        if (record.getImg() != null) {
            sql.SET("img = #{img,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{name,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{price,jdbcType=DECIMAL}");
        }
        
        if (record.getStoreAddress() != null) {
            sql.SET("store_address = #{storeAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderStarbucksExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}